org.apache.bcel.classfile

## Class StackMap

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.StackMap

- All Implemented Interfaces:
    Cloneable, Node

      public final class StackMap
      extends Attribute

  This class represents a stack map attribute used for preverification of Java classes for the Java 2 Micro Edition (J2ME). This attribute is used by the KVM and contained within the Code attribute of a method. See CLDC specification �5.3.1.2

       StackMapTable_attribute {
         u2              attribute_name_index;
         u4              attribute_length;
         u2              number_of_entries;
         stack_map_frame entries[number_of_entries];
       }

  See Also:
    `Code`, `StackMapEntry`, `StackMapType`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, EMPTY_ARRAY, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StackMap(int nameIndex, int length, StackMapEntry[] table, ConstantPool constantPool)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool constantPool)`
    `void` | `dump(DataOutputStream file)` Dump stack map table attribute to file stream in binary format.
    `int` | `getMapLength()`
    `StackMapEntry[]` | `getStackMap()`
    `void` | `setStackMap(StackMapEntry[] table)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### StackMap

          public StackMap(int nameIndex,
                          int length,
                          StackMapEntry[] table,
                          ConstantPool constantPool)

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### copy

          public Attribute copy(ConstantPool constantPool)

      Specified by:
        `copy` in class `Attribute`
      Parameters:
        `constantPool` - constant pool to save.
      Returns:
        deep copy of this attribute

    - #### dump

          public void dump(DataOutputStream file)
                    throws IOException

      Dump stack map table attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException` - if an I/O error occurs.

    - #### getMapLength

          public int getMapLength()

    - #### getStackMap

          public StackMapEntry[] getStackMap()

      Returns:
        Array of stack map entries

    - #### setStackMap

          public void setStackMap(StackMapEntry[] table)

      Parameters:
        `table` - Array of stack map entries

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation.

Copyright © 2004–2022 The Apache Software Foundation. All rights reserved.